### Method

# EDataServer Source invoke_credentials_required_sync

since: 3.16

#### Declaration [src]

    gboolean
    e_source_invoke_credentials_required_sync (
      ESource* source,
      ESourceCredentialsReason reason,
      const gchar* certificate_pem,
      GTlsCertificateFlags certificate_errors,
      const GError* op_error,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Let’s the client-side know that credentials are required. The `reason` defines which parameters are used. The client passed the credentials with an `e_source_invoke_authenticate()` call.

The `E_SOURCE_CREDENTIALS_REASON_REQUIRED` is used for the first credentials prompt, when the client can return credentials as stored from the previous success login.

The `E_SOURCE_CREDENTIALS_REASON_REJECTED` is used when the previously used credentials had been rejected by the server. That usually means that the user should be asked to provide/correct the credentials.

The `E_SOURCE_CREDENTIALS_REASON_SSL_FAILED` is used when a secured connection failed due to some server-side certificate issues.

The `E_SOURCE_CREDENTIALS_REASON_ERROR` is used when the server returned an error. It is not possible to connect to it at the moment usually.

If an error occurs, the function sets `error` and returns `FALSE`.

Available since: 3.16

#### Parameters

`reason`

  Type: `ESourceCredentialsReason`

  An `ESourceCredentialsReason`, why the credentials are required.

`certificate_pem`

  Type: `const gchar*`

  PEM-encoded secure connection certificate, or an empty string.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`certificate_errors`

  Type: `GTlsCertificateFlags`

  A bit-or of `GTlsCertificateFlags` for secure connection certificate.

`op_error`

  Type: `GError`

  A `GError` with a description of the previous credentials error, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` on error.